#!/bin/bash

test_dir=`dirname ${BASH_SOURCE[0]}`
test_name="capacity"

# valgrind helpers (active if ${RUN_TESTS_UNDER_VALGRIND}=1)
. ${test_dir}/../../.valgrind

# Remove lingering semaphores, if any.
env QKD_SERVER_FORCE_SEM_UNLINK=1 ./server_example 1001 A

# The actual test starts here.
timeout 8s ${memcheck1} ./server_example 1001 A &
# Need to give the server 2s to start up and listen on his port.
sleep 2
${memcheck2} ./client_example ${test_dir}/capacity100.cfg 2>&1 | grep Error > ${test_name}.log
sleep 8

# NOP unless ${RUN_TESTS_UNDER_VALGRIND}=1
print_valgrind_error_summary

# Remove lingering semaphores, if any.
env QKD_SERVER_FORCE_SEM_UNLINK=1 ./server_example 1001 A

# Compare test output with reference log.
diff ${test_name}.log ${test_dir}/reflog
