#ifndef ETSI_GS_QKD_004_SSL_SOCKET_CLIENT_H
#define ETSI_GS_QKD_004_SSL_SOCKET_CLIENT_H

#include <openssl/ssl.h>
#include "qkd/interfaces.h"

#ifdef __cplusplus__
extern "C" {
#endif

typedef struct qkd_client_context_data {
    const char *host;
    uint16_t port;
    const char *cert_pem;
    const char *key_pem;
    const char *peer_ca_pem;
    int min_proto_version;
    int max_proto_version;
    SSL *ssl;
} qkd_client_context_data_t;

/**
 * @brief A client must call this routine to close the SSL connection associated
 *        with the context. Failure to do so before the context goes out of
 *        scope will leak the SSL object.
 */
void qkd_client_context_close_ssl(qkd_client_context_data_t *client_context);

/**
 * @brief A client *must* call this routine in order to register
 *        the predefined interface routine implementations (or
 *        provide alternative implementations and register those).
 */
void qkd_register_client_interface_routines();

#ifdef __cplusplus__
}
#endif

#endif // ETSI_GS_QKD_004_SSL_SOCKET_CLIENT_H
