#include <assert.h>
#include <stdlib.h>
#include "qkd/models.h"

void qkd_bytes_dtor(qkd_bytes_t *b) {
    if (b == NULL) return;
    free(b->data);
    b->data = NULL;
    b->size = 0;
}

void qkd_qos_dtor(qkd_qos_t *q) {
    if (q == NULL) return;
    free(q->oc_metadata_mimetype);
    q->oc_metadata_mimetype = NULL;
    free(q->gk_metadata_mimetype);
    q->gk_metadata_mimetype = NULL;
}

void qkd_open_connect_request_dtor(qkd_open_connect_request_t *r) {
    if (r == NULL) return;
    qkd_qos_dtor(&(r->qos));
    free(r->destination_kme_id);
    r->destination_kme_id = NULL;
    free(r->source_sae_id);
    r->source_sae_id = NULL;
    free(r->destination_sae_id);
    r->destination_sae_id = NULL;
    qkd_metadata_dtor(&(r->metadata));
}

void qkd_open_connect_response_dtor(qkd_open_connect_response_t *r) {
    if (r == NULL) return;
    free(r->qos.oc_metadata_mimetype);
    r->qos.oc_metadata_mimetype = NULL;
    free(r->qos.gk_metadata_mimetype);
    r->qos.gk_metadata_mimetype = NULL;
    qkd_metadata_dtor(&(r->metadata));
}

void qkd_get_key_request_dtor(qkd_get_key_request_t *r) {
    if (r == NULL) return;
    qkd_metadata_dtor(&(r->metadata));
}

void qkd_get_key_response_dtor(qkd_get_key_response_t *r) {
    if (r == NULL) return;
    qkd_key_buffer_dtor(&(r->key_buffer));
    qkd_metadata_dtor(&(r->metadata));
}
